## opensurgsim 0.6.0

=== CMakeLists.txt ===
# This file is a part of the OpenSurgSim project.
# Copyright 2012-2013, SimQuest Solutions Inc.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.


cmake_minimum_required(VERSION 2.8)
project(OpenSurgSim)
set_property(GLOBAL PROPERTY USE_FOLDERS ON)

set(OPENSURGSIM_MAJOR_VERSION 0)
set(OPENSURGSIM_MINOR_VERSION 0)
set(OPENSURGSIM_PATCH_VERSION 0)
set(OPENSURGSIM_VERSION
	${OPENSURGSIM_MAJOR_VERSION}.${OPENSURGSIM_MINOR_VERSION}.${OPENSURGSIM_PATCH_VERSION})

# Install Directories
set(INSTALL_LIB_DIR ${CMAKE_INSTALL_PREFIX}/lib)
set(INSTALL_BIN_DIR ${CMAKE_INSTALL_PREFIX}/bin)
set(INSTALL_INCLUDE_DIR ${CMAKE_INSTALL_PREFIX}/include)
if(WIN32 AND NOT CYGWIN)
	set(INSTALL_CMAKE_DIR ${CMAKE_INSTALL_PREFIX}/CMake)
else()
	set(INSTALL_CMAKE_DIR ${CMAKE_INSTALL_PREFIX}/lib/cmake/${PROJECT_NAME})
endif()

# Use SURGSIM_SOURCE_DIR SURGSIM_SOURCE_DIR will always point to the top of the OSS Tree
set(SURGSIM_SOURCE_DIR ${CMAKE_CURRENT_SOURCE_DIR})

set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${CMAKE_CURRENT_SOURCE_DIR}/CMake)
set(SURGSIM_TOOLS_DIR "${SURGSIM_SOURCE_DIR}/Tools")
set(SURGSIM_THIRD_PARTY_DIR "${SURGSIM_SOURCE_DIR}/ThirdParty")
set(CMAKE_PREFIX_PATH ${CMAKE_PREFIX_PATH} ${SURGSIM_THIRD_PARTY_DIR})

include(ExternalProject)
include(SurgSimBuildFlags)
include(SurgSimUtilities)


### Find required libraries

find_package(OpenSceneGraph 3.2 COMPONENTS osg osgViewer osgText osgUtil osgDB osgGA osgAnimation REQUIRED)
find_package(OpenThreads)
find_package(OpenGL)
find_package(Eigen3 3.2.0 REQUIRED)

if(WIN32)
	set(GLUT_ROOT_PATH "$ENV{GLUT_ROOT_PATH}")
endif(WIN32)
find_package(GLUT)  # only needed for visual device tests
find_package(GlutFromOsg)  # look for GLUT in the OSG tree if not found above
if(${CMAKE_SYSTEM_NAME} STREQUAL "Linux")
	# The standard FindGLUT code in CMake 2.8 includes some annoying old
	# junk (-lXmu -lXi) in GLUT_LIBRARIES for Unix/Linux, which is
	# neither needed nor usually available.  We only need GLUT itself.
	set(GLUT_LIBRARIES ${GLUT_glut_LIBRARY})
endif(${CMAKE_SYSTEM_NAME} STREQUAL "Linux")

if(${BUILD_SHARED_LIBS})
	set(Boost_USE_STATIC_LIBS OFF)
	add_definitions("-DBOOST_ALL_DYN_LINK")
else()
	set(Boost_USE_STATIC_LIBS ON)
endif()
set(Boost_USE_MULTITHREADED ON)
set(Boost_USE_STATIC_RUNTIME OFF)
find_package(Boost 1.54 COMPONENTS chrono date_time filesystem system thread REQUIRED)
mark_as_advanced(Boost_DIR)

# Look for platform specific pthread.
find_package(Threads REQUIRED)
# Append pthread and rt to Boost_LIBRARIES since they are boost dependancies
list(APPEND Boost_LIBRARIES ${CMAKE_THREAD_LIBS_INIT})
if(${CMAKE_SYSTEM_NAME} STREQUAL "Linux")
	list(APPEND Boost_LIBRARIES rt)
endif()

option(USE_SYSTEM_YAMLCPP "Should we use the system yaml-cpp?" OFF)
if(USE_SYSTEM_YAMLCPP)
	find_package(yaml-cpp 0.5.1.2 EXACT REQUIRED)
else(USE_SYSTEM_YAMLCPP)
	include(External_yamlcpp)
endif(USE_SYSTEM_YAMLCPP)

include_directories(${SURGSIM_SOURCE_DIR})
include_directories(SYSTEM
	${Boost_INCLUDE_DIR}
	${EIGEN3_INCLUDE_DIR}
	${YAML_CPP_INCLUDE_DIR}
)

include(CTest)
configure_file(CTestCustom.cmake.in CTestCustom.cmake)

option(BUILD_RENDER_TESTING "Build the render testing tree." OFF)
option(BUILD_PERFORMANCE_TESTING "Build the performance testing tree." OFF)

if(BUILD_TESTING)
	set(gtest_force_shared_crt ON CACHE BOOL "Use shared CRT for Google Test [OpenSurgSim forces this to true!]" FORCE)
	find_package(GoogleMock)
	add_subdirectory(${GOOGLEMOCK_DIR} GoogleMock)
endif()

unset(EXPORT_TARGETS CACHE)
add_subdirectory(SurgSim)

option(BUILD_EXAMPLES "Build the examples." ON)

if(BUILD_EXAMPLES)
	add_subdirectory(Examples)
endif()

option(BUILD_DOCUMENTATION "Build the documentation using Doxygen." OFF)

if(BUILD_DOCUMENTATION)
  add_subdirectory(Documentation)
endif()

#OpenSurgSimConfig For the Build Tree
set(CONFIG_INCLUDE_DIRS "${SURGSIM_SOURCE_DIR}")
set(CONFIG_DATA_DIR "${SURGSIM_SOURCE_DIR}/Data")
configure_file(${CMAKE_CURRENT_SOURCE_DIR}/CMake/OpenSurgSimConfig.cmake.in
	"${PROJECT_BINARY_DIR}/OpenSurgSimConfig.cmake" @ONLY)

#OpenSurgSimConfig For the Install Tree
file(RELATIVE_PATH REL_INCLUDE_DIR "${INSTALL_CMAKE_DIR}" "${CMAKE_INSTALL_PREFIX}/include")
set(CONFIG_INCLUDE_DIRS "\${OPENSURGSIM_CMAKE_DIR}/${REL_INCLUDE_DIR}")

if (WIN32)
file(RELATIVE_PATH REL_DATA_DIR "${INSTALL_CMAKE_DIR}" "${CMAKE_INSTALL_PREFIX}/Data")
install(DIRECTORY Data/ DESTINATION ${CMAKE_INSTALL_PREFIX}/Data)
else (WIN32)
file(RELATIVE_PATH REL_DATA_DIR "${INSTALL_CMAKE_DIR}" "${CMAKE_INSTALL_PREFIX}/share/${PROJECT_NAME}")
install(DIRECTORY Data/ DESTINATION ${CMAKE_INSTALL_PREFIX}/share/${PROJECT_NAME})
endif (WIN32)
set(CONFIG_DATA_DIR "\${OPENSURGSIM_CMAKE_DIR}/${REL_DATA_DIR}")


configure_file(${CMAKE_CURRENT_SOURCE_DIR}/CMake/OpenSurgSimConfig.cmake.in
	"${PROJECT_BINARY_DIR}${CMAKE_FILES_DIRECTORY}/OpenSurgSimConfig.cmake" @ONLY)

configure_file(${CMAKE_CURRENT_SOURCE_DIR}/CMake/OpenSurgSimConfigVersion.cmake.in
	"${PROJECT_BINARY_DIR}/OpenSurgSimConfigVersion.cmake" @ONLY)


install(FILES
	"${PROJECT_BINARY_DIR}${CMAKE_FILES_DIRECTORY}/OpenSurgSimConfig.cmake"
	"${PROJECT_BINARY_DIR}/OpenSurgSimConfigVersion.cmake"
	DESTINATION "${INSTALL_CMAKE_DIR}" COMPONENT dev)
install(EXPORT ${PROJECT_NAME}Targets DESTINATION ${INSTALL_CMAKE_DIR} COMPONENT dev)

surgsim_cpplint_this_tree(cpplint)

# Set these variables for Projects using Oss inside their Project structure rather than
# Through the installed version
set(OPENSURGSIM_INCLUDE_DIRS ${SURGSIM_SOURCE_DIR} CACHE INTERNAL "OSS Include Directories")
set(OPENSURGSIM_DATA_DIR ${SURGSIM_SOURCE_DIR}/Data CACHE INTERNAL "OSS Data Directory")
set(OPENSURGSIM_LIBRARIES ${EXPORT_TARGETS} CACHE INTERNAL "OSS Exported Libraries")

=== Documentation/CMakeLists.txt ===
# This file is a part of the OpenSurgSim project.
# Copyright 2012-2013, SimQuest Solutions Inc.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.


# Make it easier to tell CMake where to find dot for doxygen.  You can
# set the environment variable DOXYGEN_DOT_PATH to a directory path to
# where the dot binary lives.  (You don't need this on Linux if you
# install Graphviz in a standard location.)
#
# Note that the Windows installer for Graphviz 2.30 doesn't seem to
# write the install directory into the registry.
find_program(DOXYGEN_DOT_EXECUTABLE
	NAMES dot
	PATHS "$ENV{DOXYGEN_DOT_PATH}" "${DOXYGEN_DOT_PATH}"
	DOC "Graphviz Dot tool for using Doxygen")

find_package(Doxygen REQUIRED)

if(EXISTS "${SURGSIM_THIRD_PARTY_DIR}/mathjax")
	set(MATHJAX_LOCAL "${SURGSIM_THIRD_PARTY_DIR}/mathjax")
else()
	set(MATHJAX_LOCAL "")
endif()

set(SURGSIM_DOCUMENTATION_EXCLUDE_LIST
	*/UnitTests/*
	CACHE STRING "Directories and files to ignore when generating documentation")
mark_as_advanced(SURGSIM_DOCUMENTATION_EXCLUDE_LIST)

set(SURGSIM_DOCUMENTATION_MATHJAX_LOCAL
	"${MATHJAX_LOCAL}"
	CACHE PATH "A local copy of MathJax to be used for HTML documentation")
mark_as_advanced(SURGSIM_DOCUMENTATION_LOCAL_MATHJAX)

set(PROJECT_LOGO "${CMAKE_CURRENT_SOURCE_DIR}/OpenSurgSim-dox.png")
set(HTML_HEADER "${CMAKE_CURRENT_SOURCE_DIR}/header.html")
set(HTML_FOOTER "${CMAKE_CURRENT_SOURCE_DIR}/footer.html")

# Set DOT_PATH to DOXYGEN_DOT_EXECUTABLE, or empty if not found.
# Eliminates whining from Doxygen.
if(DOXYGEN_DOT_FOUND)
	set(DOT_PATH "${DOXYGEN_DOT_EXECUTABLE}")
else(DOXYGEN_DOT_FOUND)
	set(DOT_PATH "")
endif(DOXYGEN_DOT_FOUND)

# Tie the documentation build to the project build.
set(DOCUMENTATION_TARGET_FLAGS ALL)

# Control the output format so warnings pop up in the Visual Studio list
if(MSVC)
	set(WARN_FORMAT "\"$file($line): warning DOC1: $text\"")
else(MSVC)
	set(WARN_FORMAT "\"$file:$line: $text\"")
endif(MSVC)

if(SURGSIM_DOCUMENTATION_MATHJAX_LOCAL STREQUAL "")
	# Use MathJax directly from the web
	set(MATHJAX_RELPATH http://www.mathjax.org/mathjax)
else()
	# Copy MathJax directly into the generated documentation
	if(NOT EXISTS "${CMAKE_CURRENT_BINARY_DIR}/html/mathjax")
		message("Copying local MathJax (please be patient)...")
		file(MAKE_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}/html/")
		file(MAKE_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}/html/mathjax/")
		file(COPY "${SURGSIM_THIRD_PARTY_DIR}/mathjax/."
			DESTINATION "${CMAKE_CURRENT_BINARY_DIR}/html/")
		message("...done!")
	endif()
	set(MATHJAX_RELPATH ./mathjax)
endif()

# Generate Doxyfile from Doxyfile.in, with @VARIABLE@ substitution.
configure_file(${CMAKE_CURRENT_SOURCE_DIR}/Doxyfile.in
	${CMAKE_CURRENT_BINARY_DIR}/Doxyfile @ONLY)

add_custom_target(documentation ${DOCUMENTATION_TARGET_FLAGS}
	${DOXYGEN_EXECUTABLE} ${CMAKE_CURRENT_BINARY_DIR}/Doxyfile
	SOURCES ${CMAKE_CURRENT_SOURCE_DIR}/Doxyfile.in
	WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
	COMMENT "Generating HTML documentation" VERBATIM)
# Put the Doxyfile.in at the top of the VS project, not "Header Files":
source_group("" FILES "${CMAKE_CURRENT_SOURCE_DIR}/Doxyfile.in")

if(UNIX)
	install(DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/html/ 
		DESTINATION share/doc/${CMAKE_PROJECT_NAME}) 
else(UNIX)
	install(DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/html/ 
		DESTINATION documentation) 
endif(UNIX)

=== Examples/CMakeLists.txt ===
# This file is a part of the OpenSurgSim project.
# Copyright 2013, SimQuest Solutions Inc.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

if(BUILD_DEVICE_MULTIAXIS)
	add_subdirectory(AddSphereFromInput)
	add_subdirectory(Stapling)
endif(BUILD_DEVICE_MULTIAXIS)

if(BUILD_DEVICE_MULTIAXIS OR BUILD_DEVICE_NOVINT)
	add_subdirectory(InputVtc)
endif(BUILD_DEVICE_MULTIAXIS OR BUILD_DEVICE_NOVINT)

add_subdirectory(DroppingBalls)

add_subdirectory(GraphicsScene)

=== SurgSim/CMakeLists.txt ===
# This file is a part of the OpenSurgSim project.
# Copyright 2012-2013, SimQuest Solutions Inc.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.


link_directories(${Boost_LIBRARY_DIRS})

add_subdirectory(Blocks)
add_subdirectory(Collision)
add_subdirectory(DataStructures)
add_subdirectory(Devices)
add_subdirectory(Framework)
add_subdirectory(Graphics)
add_subdirectory(Input)
add_subdirectory(Math)
add_subdirectory(Physics)
add_subdirectory(Testing)

=== CMake/tryCompileWdk/CMakeLists.txt ===
# This file is a part of the OpenSurgSim project.
# Copyright 2013, SimQuest Solutions Inc.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

project(tryCompileWdk)
set(TRYCOMPILEWDK_SOURCE
	main.cpp
)
add_executable(tryCompileWdk
	${TRYCOMPILEWDK_SOURCE}
)
target_link_libraries(tryCompileWdk hid setupapi)

=== Examples/AddSphereFromInput/CMakeLists.txt ===
# This file is a part of the OpenSurgSim project.
# Copyright 2013, SimQuest Solutions Inc.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

find_package(OpenSceneGraph COMPONENTS osg osgViewer osgText osgUtil osgDB osgGA osgAnimation REQUIRED)
find_package(OpenThreads)

link_directories(
	${Boost_LIBRARY_DIRS}
)

include_directories(
	${CMAKE_CURRENT_SOURCE_DIR}
	${OSG_INCLUDE_DIR}
	${OPENTHREADS_INCLUDE_DIR}
)

set(SOURCES
	AddSphereBehavior.cpp
	AddSphereFromInput.cpp
)

set(HEADERS
	AddSphereBehavior.h
)

add_executable(AddSphereFromInput ${SOURCES} ${HEADERS})
surgsim_show_ide_folders("${SOURCES}" "${HEADERS}")

set(LIBS 
	MultiAxisDevice
	SurgSimBlocks
	SurgSimGraphics
	SurgSimMath
	${YAML_CPP_LIBRARIES}
)

target_link_libraries(AddSphereFromInput ${LIBS})

# Put AddSphereFromInput into folder "Examples"
set_target_properties(AddSphereFromInput PROPERTIES FOLDER "Examples")

=== Examples/DroppingBalls/CMakeLists.txt ===
# This file is a part of the OpenSurgSim project.
# Copyright 2013, SimQuest Solutions Inc.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

link_directories(
	${Boost_LIBRARY_DIRS}
)

include_directories(
	${CMAKE_CURRENT_SOURCE_DIR}
	${OSG_INCLUDE_DIR}
	${OPENTHREADS_INCLUDE_DIR}
)

set(SOURCES
	AddRandomSphereBehavior.cpp
	DroppingBalls.cpp
)

set(HEADERS
	AddRandomSphereBehavior.h
)

file(COPY ${CMAKE_CURRENT_SOURCE_DIR}/Data DESTINATION ${CMAKE_CURRENT_BINARY_DIR})

# Configure the path for the data files
configure_file(
	"${CMAKE_CURRENT_SOURCE_DIR}/config.txt.in"
	"${CMAKE_CURRENT_BINARY_DIR}/config.txt"
)

add_executable(DroppingBalls ${SOURCES} ${HEADERS})
surgsim_show_ide_folders("${SOURCES}" "${HEADERS}")

SET(LIBS
	SurgSimBlocks
	SurgSimPhysics
	SurgSimGraphics
	SurgSimMath
	${YAML_CPP_LIBRARIES}
)

target_link_libraries(DroppingBalls ${LIBS})

# Put DroppingBalls into folder "Examples"
set_target_properties(DroppingBalls PROPERTIES FOLDER "Examples")

=== Examples/GraphicsScene/CMakeLists.txt ===
# This file is a part of the OpenSurgSim project.
# Copyright 2013, SimQuest Solutions Inc.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

find_package(OpenSceneGraph COMPONENTS osg osgViewer osgText osgUtil osgDB osgGA osgAnimation REQUIRED)
find_package(OpenThreads)

link_directories(
	${Boost_LIBRARY_DIRS}
)

include_directories(
	"${CMAKE_CURRENT_SOURCE_DIR}"
	"${OSG_INCLUDE_DIR}"
	"${OPENTHREADS_INCLUDE_DIR}"
)

set(SOURCES
	GraphicsScene.cpp
)

set(HEADERS
)

file(COPY ${CMAKE_CURRENT_SOURCE_DIR}/Data DESTINATION ${CMAKE_CURRENT_BINARY_DIR})

# Configure the path for the data files
configure_file(
	"${CMAKE_CURRENT_SOURCE_DIR}/config.txt.in"
	"${CMAKE_CURRENT_BINARY_DIR}/config.txt"
)

add_executable(GraphicsScene ${SOURCES} ${HEADERS})
surgsim_show_ide_folders("${SOURCES}" "${HEADERS}")

SET(LIBS
	SurgSimBlocks
	SurgSimGraphics
	${YAML_CPP_LIBRARIES}
)

target_link_libraries(GraphicsScene ${LIBS})

# Put GraphicsScene into folder "Examples"
set_target_properties(GraphicsScene PROPERTIES FOLDER "Examples")

=== Examples/InputVtc/CMakeLists.txt ===
# This file is a part of the OpenSurgSim project.
# Copyright 2013, SimQuest Solutions Inc.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

link_directories(
	${Boost_LIBRARY_DIRS}
)

include_directories(
	${CMAKE_CURRENT_SOURCE_DIR}
	${OSG_INCLUDE_DIR}
	${OPENTHREADS_INCLUDE_DIR}
)

set(SOURCES
	DeviceFactory.cpp
	InputVtc.cpp
)

set(HEADERS
	DeviceFactory.h
)

add_executable(InputVtc ${SOURCES} ${HEADERS})

set(LIBS 
	IdentityPoseDevice
	SurgSimBlocks
	SurgSimGraphics
	SurgSimMath
	${YAML_CPP_LIBRARIES}
)

if(BUILD_DEVICE_MULTIAXIS)
	list(APPEND LIBS MultiAxisDevice)
	set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -DMULTIAXISDEVICE_LIBRARY_AVAILABLE")
endif(BUILD_DEVICE_MULTIAXIS)

if(BUILD_DEVICE_NOVINT)
	list(APPEND LIBS NovintDevice)
	set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -DNOVINT_LIBRARY_AVAILABLE")
endif(BUILD_DEVICE_NOVINT)

target_link_libraries(InputVtc ${LIBS})

# Put InputVtc into folder "Examples"
set_target_properties(InputVtc PROPERTIES FOLDER "Examples")

=== Examples/Stapling/CMakeLists.txt ===
# This file is a part of the OpenSurgSim project.
# Copyright 2013, SimQuest Solutions Inc.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

include_directories(
	${CMAKE_CURRENT_SOURCE_DIR}
	${OSG_INCLUDE_DIR}
)

set(SOURCES
	StapleElement.cpp
	StaplerBehavior.cpp
)

set(HEADERS
	StapleElement.h
	StaplerBehavior.h
)

add_executable(Stapling
	Stapling.cpp
	${SOURCES}
	${HEADERS}
)

add_executable(SerializedStapling
	SerializedStapling.cpp
	${SOURCES}
	${HEADERS}
)

add_dependencies(SerializedStapling yaml-cpp)

surgsim_show_ide_folders("Main.cpp SerializedMain.cpp ${SOURCES}" "${HEADERS}")

set(LIBS 
	IdentityPoseDevice
	MultiAxisDevice
	SurgSimBlocks
	SurgSimFramework
	SurgSimGraphics
	${YAML_CPP_LIBRARIES}
)
target_link_libraries(Stapling ${LIBS})
target_link_libraries(SerializedStapling ${LIBS})

file(COPY ${CMAKE_CURRENT_SOURCE_DIR}/Data DESTINATION ${CMAKE_CURRENT_BINARY_DIR})

# Configure the path for the data files
configure_file(
	"${CMAKE_CURRENT_SOURCE_DIR}/config.txt.in"
	"${CMAKE_CURRENT_BINARY_DIR}/config.txt"
)

set_target_properties(Stapling PROPERTIES FOLDER "Examples") 
set_target_properties(SerializedStapling PROPERTIES FOLDER "Examples")

=== SurgSim/Blocks/CMakeLists.txt ===
# This file is a part of the OpenSurgSim project.
# Copyright 2012-2013, SimQuest Solutions Inc.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

include_directories(
	${OSG_INCLUDE_DIR}
	${OPENTHREADS_INCLUDE_DIR}
)

set(SURGSIM_BLOCKS_SOURCES
	DriveElementFromInputBehavior.cpp
	KeyboardTogglesComponentBehavior.cpp
	MassSpring1DRepresentation.cpp
	MassSpring2DRepresentation.cpp
	MassSpring3DRepresentation.cpp
	MassSpringNDRepresentationUtils.cpp
	PoseInterpolator.cpp
	SphereElement.cpp
	TransferPhysicsToGraphicsMeshBehavior.cpp
	TransferPhysicsToPointCloudBehavior.cpp
	VisualizeContactsBehavior.cpp
)

set(SURGSIM_BLOCKS_HEADERS
	DriveElementFromInputBehavior.h
	KeyboardTogglesComponentBehavior.h
	MassSpring1DRepresentation.h
	MassSpring2DRepresentation.h
	MassSpring3DRepresentation.h
	MassSpringNDRepresentationUtils.h
	PoseInterpolator.h
	SphereElement.h
	TransferPhysicsToGraphicsMeshBehavior.h
	TransferPhysicsToPointCloudBehavior.h
	VisualizeContactsBehavior.h
)

surgsim_add_library(
	SurgSimBlocks
	"${SURGSIM_BLOCKS_SOURCES}"
	"${SURGSIM_BLOCKS_HEADERS}"
	"SurgSim/Blocks"
)

SET(LIBS
	SurgSimFramework
	SurgSimPhysics
	${Boost_LIBRARIES}
)

target_link_libraries(SurgSimBlocks ${LIBS}
)

if(BUILD_TESTING)
	add_subdirectory(UnitTests)
endif()

# Put SurgSimBlocks into folder "Blocks"
set_target_properties(SurgSimBlocks PROPERTIES FOLDER "Blocks")

=== SurgSim/Collision/CMakeLists.txt ===
# This file is a part of the OpenSurgSim project.
# Copyright 2012-2013, SimQuest Solutions Inc.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

set(SURGSIM_COLLISION_SOURCES
	BoxCapsuleDcdContact.cpp
	BoxDoubleSidedPlaneDcdContact.cpp
	BoxPlaneDcdContact.cpp
	BoxSphereDcdContact.cpp
	CapsuleSphereDcdContact.cpp
	CollisionPair.cpp
	ContactCalculation.cpp
	DefaultContactCalculation.cpp
	OctreeDcdContact.cpp
	Representation.cpp
	ShapeCollisionRepresentation.cpp
	SphereDoubleSidedPlaneDcdContact.cpp
	SpherePlaneDcdContact.cpp
	SphereSphereDcdContact.cpp
	TriangleMeshPlaneDcdContact.cpp
	TriangleMeshTriangleMeshDcdContact.cpp
)

set(SURGSIM_COLLISION_HEADERS
	BoxCapsuleDcdContact.h
	BoxDoubleSidedPlaneDcdContact.h
	BoxPlaneDcdContact.h
	BoxSphereDcdContact.h
	CapsuleSphereDcdContact.h
	CollisionPair.h
	ContactCalculation.h
	DcdCollision.h
	DefaultContactCalculation.h
	OctreeDcdContact.h
	Representation.h
	ShapeCollisionRepresentation.h
	SphereDoubleSidedPlaneDcdContact.h
	SpherePlaneDcdContact.h
	SphereSphereDcdContact.h
	TriangleMeshPlaneDcdContact.h
	TriangleMeshTriangleMeshDcdContact.h
)

surgsim_add_library(
	SurgSimCollision
	"${SURGSIM_COLLISION_SOURCES}"
	"${SURGSIM_COLLISION_HEADERS}"
	"SurgSim/Collision"
)

SET(LIBS
	SurgSimFramework
	SurgSimMath
	${Boost_LIBRARIES}
)

target_link_libraries(SurgSimCollision ${LIBS}
)

if(BUILD_TESTING)
	add_subdirectory(UnitTests)
endif()

# Put SurgSimCollision into folder "Collision"
set_target_properties(SurgSimCollision PROPERTIES FOLDER "Collision")

=== debian/changelog ===
opensurgsim (0.6.0-5) unstable; urgency=medium

  * Fix unit test timeouts on multiple archs
  * Disables two sensitive unit tests

 -- Paul Novotny <paul@paulnovo.us>  Sun, 15 Nov 2015 08:57:33 -0500

opensurgsim (0.6.0-4) unstable; urgency=medium

  * Fixes for eigen 3.3-alpha1 (Closes: #803145)
  * Disables eigen alignment on ppc64el and ppc64

 -- Paul Novotny <paul@paulnovo.us>  Sun, 08 Nov 2015 15:37:31 -0500

opensurgsim (0.6.0-3) unstable; urgency=low

  * Disables eigen alignment on i386 and powerpc (Closes: #798693)
  * Fixes TimerTest failures on mips, mipsel, and s390x (Closes: #798718)
  * Fixes unit tests off on some architectures (Closes: #798717)
  * Fixes FEM ply reading on s390x and ppc64 (Closes: #798715)

 -- Paul Novotny <paul@paulnovo.us>  Sun, 20 Sep 2015 12:30:15 -0400

opensurgsim (0.6.0-2) unstable; urgency=low

  [ Paul Novotny ]
  * Updates for yaml-cpp 0.5.2
  * Backport fixes for compiling with GCC 5
  * Remove unneeded unit test libraries from package
  
  [ Andreas Tille ]
  * Fix Vcs fields via `cme fix dpkg-control`

 -- Paul Novotny <paul@paulnovo.us>  Thu, 10 Sep 2015 09:04:24 -0400

opensurgsim (0.6.0-1) experimental; urgency=low

  * Initial release (Closes: #775753)

 -- Paul Novotny <paul@paulnovo.us>  Thu, 22 Jan 2015 17:33:51 -0500

=== debian/control ===
Source: opensurgsim
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders: Paul Novotny <paul@paulnovo.us>
Section: science
Priority: optional
Build-Depends: debhelper (>= 9),
               dh-linktree,
               libboost-chrono-dev,
               libboost-date-time-dev,
               libboost-filesystem-dev,
               libboost-system-dev,
               libboost-thread-dev,
               cmake,
               doxygen,
               libeigen3-dev,
               google-mock,
               libjs-jquery,
               libjs-mathjax,
               libopenscenegraph-dev,
               libyaml-cpp-dev (>= 0.5.2)
Standards-Version: 3.9.6
Vcs-Browser: https://anonscm.debian.org/cgit/debian-med/opensurgsim.git
Vcs-Git: git://anonscm.debian.org/debian-med/opensurgsim.git
Homepage: http://www.opensurgsim.org/

Package: libopensurgsim
Architecture: any
Section: libs
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: Free platform for surgical simulation - runtime
 OpenSurgSim is C++ toolkit for developing real-time surgical simulations. It
 lets you build simulators using the included building blocks, such as input
 device support, haptic feedback, graphics, collision detection and physics
 simulation.
 .
 This package contains the libraries needed to run OpenSurgSim
 applications.

Package: libopensurgsim-dev
Architecture: any
Section: libdevel
Depends: ${misc:Depends},
         libopensurgsim (= ${binary:Version})
Description: Free platform for surgical simulation - development
 OpenSurgSim is C++ toolkit for developing real-time surgical simulations. It
 lets you build simulators using the included building blocks, such as input
 device support, haptic feedback, graphics, collision detection and physics
 simulation.
 .
 This package contains the development files needed to build your
 own OpenSurgSim applications.

Package: opensurgsim-doc
Architecture: all
Section: doc
Depends: ${misc:Depends},
         libjs-mathjax
Suggests: libopensurgsim-dev,
          libopensurgsim
Description: Free platform for surgical simulation - documentation
 OpenSurgSim is C++ toolkit for developing real-time surgical simulations. It
 lets you build simulators using the included building blocks, such as input
 device support, haptic feedback, graphics, collision detection and physics
 simulation.
 .
 This package contains the Doxygen documentation files.

=== debian/rules ===
#!/usr/bin/make -f

#DH_VERBOSE = 1

export DEB_BUILD_MAINT_OPTIONS = hardening=-format

%:
	dh $@ --parallel --with linktree

ifeq (,$(filter $(DEB_BUILD_ARCH),i386 powerpc ppc64el ppc64))
    EIGEN_ALIGNMENT=ON
else
    EIGEN_ALIGNMENT=OFF
endif

override_dh_auto_configure:
	dh_auto_configure -- \
	-DCMAKE_LIBRARY_PATH=$(DEB_HOST_MULTIARCH) \
	-DCMAKE_INSTALL_PREFIX:PATH=/usr \
	-DBUILD_DEVICE_MULTIAXIS:BOOL=ON \
	-DBUILD_DOCUMENTATION:BOOL=ON \
	-DBUILD_EXAMPLES:BOOL=OFF \
	-DBUILD_SHARED_LIBS:BOOL=ON \
	-DBUILD_TESTING_EIGEN:BOOL=ON \
	-DCTEST_CUSTOM_TESTS_IGNORE="MultiAxisDeviceTest" \
	-DEIGEN_ALIGNMENT=$(EIGEN_ALIGNMENT) \
	-DUSE_SYSTEM_YAMLCPP:BOOL=ON

=== debian/watch ===
version=3

opts=filenamemangle=s/.+\/v?(\d\S*)\.tar\.gz/opensurgsim-$1\.tar\.gz/ \
  https://github.com/simquest/opensurgsim/releases .*/v?(\d\S*)\.tar\.gz
